/*
 * TEI_MEK_verse_parser.java
 *
 * Created on 2005. december 16., 15:59
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package OpenReader;

import javax.microedition.lcdui.*;

import org.xml.sax.helpers.*;
import org.xml.sax.*;

/**
 *
 * @author pzoli
 */
public class TEI_MEK_verse_parser extends DefaultHandler{
    private StringBuffer path = new StringBuffer();
    private Displayable fdisplay;
    private String dtype;
    private String head;
    private boolean chapterfound;
    
    public String idx;
    public int fProcType;
    
    /** Creates a new instance of TEI_MEK_verse_parser */
    public TEI_MEK_verse_parser(Displayable idisp) {
        fdisplay=idisp;
    }
    
    public void startElement(java.lang.String uri, java.lang.String localName, java.lang.String qName, Attributes attributes)
    throws SAXException {
        final String tagname = qName.toLowerCase().trim();
        path.append("/"+tagname);
        switch(fProcType)
        {
            case 0:
                if (tagname.equals("div"))
                  dtype=attributes.getValue("type");
                break;
            case 1:
                /*if (path.toString().equals("/tei.2/text/body/div/head/lb"))
                    ((Form)fdisplay).append("<lb>");
                else*/
                if (path.toString().equals("/tei.2/text/body/div/head")) {
                    chapterfound=false;
                    head=null;
                }
                break;
        }
    }
    
    public void startDocument() throws SAXException {
        
    }
    
    public void endElement(String uri, String localName, String qName) throws SAXException {
        switch(fProcType) {
            case 0:
                if (path.toString().equals("/tei.2/text/front/div")) {
                    if ((dtype!=null) && dtype.equals("contents")) throw new SAXException("break") ;
                }
                break;
            case 1:
                /*if (path.toString().equals("/tei.2/text/body/div/head/lb"))
                    ((Form)fdisplay).append("</lb>\n");
                else*/
                if (path.toString().equals("/tei.2/text/body/div/head")) {
                    if (idx.startsWith(head)) chapterfound=true;
                    //else
                    //    ((Form)fdisplay).append("!="+head+"\n");
                }else
                if (path.toString().equals("/tei.2/text/body/div")) {
                    if (chapterfound) throw new SAXException("break");
                }else
                if (path.toString().equals("/tei.2/text/body/div/lg")){
                    if (chapterfound)
                       ((Form)fdisplay).append(" \n");
                }
                break;
        }
        path.setLength(path.length()-(qName.length()+1));
    }
    
    public void endDocument() {
        switch(fProcType)
        {
            case 0: break;
            case 1: ((Form)fdisplay).append("...\n"); break;
        }
    }
    
    public void characters(char[] ch, int start, int length) throws SAXException {
        switch(fProcType) {
            case 0:
                if (path.toString().equals("/tei.2/text/front/div/p")) {
                    if ((dtype!=null) && dtype.equals("contents"))
                        ((List)fdisplay).append((new String(ch, start, length)).trim(),null);
                }
                break;
            case 1:
                if (path.toString().equals("/tei.2/text/body/div/head")) {
                    if (head!=null)
                        head.concat(" "+(new String(ch,start,length)).toLowerCase().trim());
                    else
                        head = new String(ch,start,length).toLowerCase().trim();
                }else
                if (path.toString().equals("/tei.2/text/body/div/lg/l")){
                    if (chapterfound)
                      ((Form)fdisplay).append((new String(ch, start, length)).trim()+"\n");
                }
                break;
        }
    }
    
}
